//! @file usb_host_enum.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧قνė(ڑF)菇Ǘ܂B
//!
//! @version 1.13 at90usb128-otg-dual_role-toggle-1_0_0 $Id: usb_host_enum.c,v 1.13 2007/02/13 10:13:50 arobert Exp $
//!
//! @todo
//! @bug

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "lib_mcu/usb/usb_drv.h"
#include "usb_host_enum.h"
#include "modules/usb/usb_task.h"
#include "usb_host_task.h"

#if ((USB_OTG_FEATURE == ENABLED) && (TARGET_BOARD==SPIDER))
  #include "lib_board/lcd/lcd_drv.h"
#endif

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//_____ I錾 ___________________________________________________________

#if (USB_HOST_FEATURE == DISABLED)
  #warning trying to compile a file used with the USB HOST without USB_HOST_FEATURE enabled
#endif

#if (MAX_INTERFACE_SUPPORTED<1)
  #error MAX_INTERFACE_SUPPORTED<1 : The host controller should support at least one interface...
#endif

#if (USB_HOST_FEATURE == ENABLED)
extern S_usb_setup_data usb_request;

#ifndef VID_PID_TABLE
  #error VID_PID_TABLE should be defined somewhere (conf_usb.h)
  //  VID_PID_TABLE``:
  //  #define VID_PID_TABLE		{VID1, number_of_pid_for_this_VID1, PID11_value,..., PID1X_Value \
  //							 ...\
  //							,VIDz, number_of_pid_for_this_VIDz, PIDz1_value,..., PIDzX_Value}
#endif

#ifndef CLASS_SUBCLASS_PROTOCOL
  #error CLASS_SUBCLASS_PROTOCOL shoud be defined somewhere (conf_usb.h)
  //  CLASS_SUBCLASS_PROTOCOL``:
  //  #define CLASS_SUBCLASS_PROTOCOL	{CLASS1, SUB_CLASS1,PROTOCOL1, \
  //									 ...\
  //									 CLASSz, SUB_CLASSz,PROTOCOLz}
#endif

//! m̑u̒萔\(\eɂĂconf_usb.hB)
U16 registered_VID_PID[] = VID_PID_TABLE;

//! m̸׽̒萔\(\eɂĂconf_usb.hB)
U8 registered_class[] = CLASS_SUBCLASS_PROTOCOL;

//! u߲ĎQƕ\ڽw肷邽߂߲̕
//  ̕\"host_configure_endpoint_class"֐œIɍ\z܂B
U8 ep_table[MAX_EP_NB]={0,0,0,0,0,0,0};

//! ڑꂽuνĂx邱Ƃł̪
U8 nb_interface_supported=0;

S_interface interface_supported[MAX_INTERFACE_SUPPORTED];

//! ڑꂽuPID
U16 device_PID;
//! ڑꂽuVID
U16 device_VID;
//! ڑꂽubmAttributes޲
U8 bmattributes;
//! ڑꂽumaxpower޲(:Pʂ2mA)
U8 maxpower;

//_____ 錾 _______________________________________________________________

/**
 * host_check_VID_PID
 *
 * @brief ̊֐VIDPIDx邩(VID/PIDVID_PID\ɑ)𒲂ׂ܂B
 *
 * @param	Ȃ
 *
 * @return	status
 */
U8 host_check_VID_PID (void)
{
	U8 c,d;

	// ްiVIDPIDč\z
	LSB(device_VID) = data_stage[OFFSET_FIELD_LSB_VID];
	MSB(device_VID) = data_stage[OFFSET_FIELD_MSB_VID];
	LSB(device_PID) = data_stage[OFFSET_FIELD_LSB_PID];
	MSB(device_PID) = data_stage[OFFSET_FIELD_MSB_PID];

	// oꂽVIDPIDx\Ɣr
	c=0;

	while (c< sizeof(registered_VID_PID)/2)		// registered_VID_PID\U16̂߂/2
	{
		if (registered_VID_PID[c] == device_VID)	// VID͐
		{
			d = (U8)registered_VID_PID[c+1];	// VIDpPIDi[
			while (d != 0)
			{
				if (registered_VID_PID[c+d+1] == device_PID)
				{
					return HOST_TRUE;
				}
				d--;
			}
		}
		c+=registered_VID_PID[c+1]+2;
	}
	return HOST_FALSE;
}

#if (USB_OTG_FEATURE == ENABLED)
/**
 * host_check_OTG_features
 *
 * @brief ̊֐OTGLqqx@\󂯎Ďꂽ𒲂ׂ܂B
 *
 * @param	Ȃ
 *
 * @return	status
 */
U8 host_check_OTG_features (void)
{
	U8 index;								// OTGLqqɎgpϕψ(̾)
	U8 nb_bytes;							// `ԐݒLqq޲Đ

	Peripheral_is_not_otg_device();			// 
	otg_features_supported = 0;

	nb_bytes = data_stage[OFFSET_FIELD_TOTAL_LENGHT];
	index = 0;
	if (nb_bytes > 0x09)					// ꂪꂽ/sSȌ`ԐݒLqqłȂƂ𒲍
	{
		while (index < nb_bytes)			// Lqq
		{
			if (data_stage[index+OFFSET_FIELD_DESCRIPTOR_TYPE] != OTG_DESCRIPTOR)	// wꂽLqqOTGLqq?
			{
				index += data_stage[index+OFFSET_DESCRIPTOR_LENGHT];	// A̋Lqq֔
			}
			else
			{
				if (data_stage[index+OFFSET_DESCRIPTOR_LENGHT] == OTG_DESCRIPTOR_bLength)	// ͂ALqq
				{
					Peripheral_is_otg_device();	// OTGLqq
					otg_features_supported = data_stage[index+OFFSET_FIELD_OTG_FEATURES];	// xOTG@\ݒ
					return HOST_TRUE;
				}
				else
				{
					return HOST_FALSE;		// sLqq
				}
			}
		}
	}
	else
	{
		return HOST_FALSE;					// ͌ꂽ/sSȌ`ԐݒLqqłB
	}
	return HOST_TRUE;
}
#endif

/**
 * host_check_class
 *
 * @brief ̊֐͑u׽x邩𒲂ׂ܂B
 * ֐͎󂯎LqqŐ錾SĂ̲̪A1
 * CLASS/SUB_CLASS/PROTOCOL tableƈv邩܂B
 *
 * @param	Ȃ
 *
 * @return	status
 */
U8 host_check_class (void)
{
	U8  c;
	T_DESC_OFFSET descriptor_offset;
	T_DESC_OFFSET conf_offset_end;
	U16 config_size;
	U8  device_class;
	U8  device_subclass;
	U8  device_protocol;

	nb_interface_supported=0;				// ŏɲ̪xȂƉ!
	if (data_stage[OFFSET_FIELD_DESCRIPTOR_TYPE] != CONFIGURATION_DESCRIPTOR)	// `ԐݒLqq
	{ return HOST_FALSE;}
	LSB(config_size) = data_stage[OFFSET_FIELD_TOTAL_LENGHT];
	MSB(config_size) = data_stage[OFFSET_FIELD_TOTAL_LENGHT+1];
	bmattributes = data_stage[OFFSET_FIELD_BMATTRIBUTES];
	maxpower = data_stage[OFFSET_FIELD_MAXPOWER];
	descriptor_offset = 0;
	conf_offset_end = descriptor_offset + config_size;

	// `ԐݒŐ錾ꂽS̪
	while(descriptor_offset < conf_offset_end)
	{
		// ̲̪LqqTB
		while (data_stage[descriptor_offset+OFFSET_FIELD_DESCRIPTOR_TYPE] != INTERFACE_DESCRIPTOR)
		{
			descriptor_offset += data_stage[descriptor_offset];
			if(descriptor_offset >= conf_offset_end)
			{
				if(nb_interface_supported)
				{ return HOST_TRUE; }
				else return HOST_FALSE;
			}
		}
		// ̪Lqq
		// ̲̪̓擾
		device_class    = data_stage[descriptor_offset + OFFSET_FIELD_CLASS];
		device_subclass = data_stage[descriptor_offset + OFFSET_FIELD_SUB_CLASS];
		device_protocol = data_stage[descriptor_offset + OFFSET_FIELD_PROTOCOL];
		// vɊւēo^ꂽ׽\ŌB
		c=0;
		while (c< sizeof(registered_class))
		{
			if (registered_class[c] == device_class)	// ׽͐!
			{
				if (registered_class[c+1] == device_subclass)	// ׽͐!
				{
					if (registered_class[c+2] == device_protocol)	// K͐!
					{
						// \ŕʂ̍CLASS/SUB_CLASS/PROTOCOLɊւď
						c+=3;
						// x̪ƂĂ̲̪ۑ
						// ̲̪ԍL
						interface_supported[nb_interface_supported].interface_nb=data_stage[descriptor_offset+OFFSET_FIELD_INTERFACE_NB];
						// ֐ݒ
						interface_supported[nb_interface_supported].altset_nb=data_stage[descriptor_offset+OFFSET_FIELD_ALT];
						// USB׽
						interface_supported[nb_interface_supported].class=device_class;
						// USB׽
						interface_supported[nb_interface_supported].subclass=device_subclass;
						// USBK
						interface_supported[nb_interface_supported].protocol=device_protocol;
						// ̲̪ƒg߲Đ
						// :g߲ ڽ߲ߋAɊi[܂B
						interface_supported[nb_interface_supported].nb_ep=data_stage[descriptor_offset+OFFSET_FIELS_NB_OF_EP];
						// x̪XV
						nb_interface_supported++;
						// xłő̪
						if(nb_interface_supported>=MAX_INTERFACE_SUPPORTED)
						{
							return HOST_TRUE;
						}
					}
				}
			}
			c+=3;							// \ő̍CLASS/SUB_CLASS/PROTOCOL𒲍
		}
		descriptor_offset += data_stage[descriptor_offset];	// ̋Lqq
		if(descriptor_offset > SIZEOF_DATA_STAGE)	// ꌟ
		{
			if(nb_interface_supported)
			{ return HOST_TRUE; }
			else return HOST_FALSE;
		}
	}
	if(nb_interface_supported)
	{ return HOST_TRUE; }
	else return HOST_FALSE;
}

 /**
 * @brief ̊֐͑I̸̪׽ɏ]߲߂`Ԑݒ肵܂B
 * ֐͍ŌɑIꂽlɑΉ߲߂`Ԑݒ肵܂B
 *
 * @return	status
 */
U8 host_auto_configure_endpoint()
{
	U8 nb_endpoint_to_configure;
	T_DESC_OFFSET  descriptor_offset;
	U8 physical_pipe=1;					// =1AQƕ\͕߲0pɗ\񂳂Ƃ̉肵܂B
	U8 i;
	U8 ep_index;

	// `Ԑݒ肷SĂ̲̪ɑ΂
	for(i=0;i<nb_interface_supported;i++)
	{
		ep_index=0;
		// ŏɖڕW̪Lqqψ(̾)TB
		descriptor_offset = get_interface_descriptor_offset(interface_supported[i].interface_nb,interface_supported[i].altset_nb);
		// ̲̪ɊւČ`Ԑݒ肷߲Đ擾
		nb_endpoint_to_configure = data_stage[descriptor_offset+OFFSET_FIELS_NB_OF_EP];
		// `Ԑݒ肷ŏ̴߲ċLqqψʂ擾
		descriptor_offset += data_stage[descriptor_offset+OFFSET_DESCRIPTOR_LENGHT];  // pointing on endpoint descriptor

		// `Ԑݒ肷Œ1߲߂
		while (nb_endpoint_to_configure)
		{
			// ߲ċLqqTČ
			while (data_stage[descriptor_offset+OFFSET_FIELD_DESCRIPTOR_TYPE] != ENDPOINT_DESCRIPTOR)
			{
				descriptor_offset += data_stage[descriptor_offset];
				if(descriptor_offset > SIZEOF_DATA_STAGE)	// ȏ߲ċLqq݂Ȃˈُ!
				{ return HOST_FALSE; }
			}

			// `Ԑݒ肷V߲߂IĂ߲̕߂ɑ΂ĂǂꂩǑ`Ԑݒ̏㏑擾
			Host_select_pipe(physical_pipe);
			Host_disable_pipe();
			Usb_unallocate_memory();
			Host_enable_pipe();

			// 󂯎߲ċLqqɏ]߲ߌ`Ԑݒ\z
			//
//			host_configure_pipe(
//				physical_pipe,																		// USB̪߲ߔԍ
//				data_stage[descriptor_offset+OFFSET_FIELD_EP_TYPE],									// ߲ߌ`(荞/(ٸ)/)
//				Get_pipe_token(data_stage[descriptor_offset+OFFSET_FIELD_EP_ADDR]),					// ߲ ڽ
//				(data_stage[descriptor_offset+2] & MSK_EP_DIR),										// ߲ߕ(IN/OUT)
//				host_determine_pipe_size((U16)data_stage[descriptor_offset+OFFSET_FIELD_EP_SIZE]),	// ߲ߗe
//				ONE_BANK,																			// ߲߂Ɋ蓖Ăݸ
//				data_stage[descriptor_offset+OFFSET_FIELD_EP_INTERVAL]								// 荞ݎ(荞߲߂ɑ΂)
//			);
			host_configure_pipe(																	\
				physical_pipe,																		\
				data_stage[descriptor_offset+OFFSET_FIELD_EP_TYPE],									\
				Get_pipe_token(data_stage[descriptor_offset+OFFSET_FIELD_EP_ADDR]),					\
				(data_stage[descriptor_offset+OFFSET_FIELD_EP_ADDR] & MSK_EP_DIR),					\
				host_determine_pipe_size((U16)data_stage[descriptor_offset+OFFSET_FIELD_EP_SIZE]),	\
				ONE_BANK,																			\
				data_stage[descriptor_offset+OFFSET_FIELD_EP_INTERVAL]								\
			);

			// u߲ ڽŕ߲ߎQƕ\XV
			ep_table[physical_pipe]=data_stage[descriptor_offset+OFFSET_FIELD_EP_ADDR];
			physical_pipe++;
			// x̪\̂Ŵ߲ ڽ\XV
			interface_supported[i].ep_addr[ep_index++]=data_stage[descriptor_offset+OFFSET_FIELD_EP_ADDR];
			descriptor_offset += data_stage[descriptor_offset];	// ̋Lqqw

			// SڕW߲Č`Ԑݒ?
			nb_endpoint_to_configure--;
		} //for(i=0;i<nb_interface_supported;i++)
	}
	Host_set_configured();
	return HOST_TRUE;
}

/**
 * @brief ̊֐͔ԍƑ֐ݒ肪ҰƂēn̪Lqq
 * data_stageł̕ψ(̾)Ԃ܂B
 *
 * @param	interface		LqψʂT̪ԍ
 * @param	alt				̪֐ݒԍ
 *
 * @return	T_DESC_OFFSET	data_stage[]̕ψ
 */
T_DESC_OFFSET get_interface_descriptor_offset (U8 interface, U8 alt)
{
	U8 nb_interface;
	T_DESC_OFFSET descriptor_offset;

	nb_interface = data_stage[OFFSET_FIELD_NB_INTERFACE];		// ̌`Ԑݒ̲̪o
	descriptor_offset = data_stage[OFFSET_DESCRIPTOR_LENGHT];	// ⎟̋Lqqw

	while(descriptor_offset < SIZEOF_DATA_STAGE)	// `ԐݒŐ錾ꂽSĂ̲̪B
	{
		while (data_stage[descriptor_offset+OFFSET_FIELD_DESCRIPTOR_TYPE] != INTERFACE_DESCRIPTOR)
		{
			descriptor_offset += data_stage[descriptor_offset];
			if(descriptor_offset > SIZEOF_DATA_STAGE)
			{ return HOST_FALSE; }
		}
		if (data_stage[descriptor_offset+OFFSET_FIELD_INTERFACE_NB]==interface
		 && data_stage[descriptor_offset+OFFSET_FIELD_ALT]==alt)
		{
			return  descriptor_offset;
		}
		descriptor_offset += data_stage[descriptor_offset];
	}
	return descriptor_offset;
}

/**
 * @brief ̊֐͘_߲ ڽɌq߲ߔԍԂ܂B
 *
 * @param	ep_addr
 *
 * @return	physical_pipe_number
 *
 * @note	֐͎Qƕ\ep_addrȂꍇ0Ԃ܂B
 */
U8 host_get_hwd_pipe_nb (U8 ep_addr)
{
	U8 i;
	for(i=0;i<MAX_EP_NB;i++)
	{
		if(ep_table[i]==ep_addr)
		{ return i; }
	}
	return 0;
}

/**
 * host_send_control
 *
 * @brief ̊֐͕W߲0Ǘ֐łB
 * ̊֐߲0ł̐v̑oƎ󂯎Ɏgp܂B
 *
 * @todo	ҋ@JԂł̑SĂ̎Ԓ߈ُƐؒf𒼂ĂB
 *
 * @param	data_pointer
 *
 * @return	
 *
 * @note	̊֐ҰƂusb_requestS\̂gp܂B
 * ]Ă̊֐ĂԑOɂ̍\ׂ͖̂łB
 *
 */
U8 host_send_control (U8* data_pointer)
{
	U16 data_length;
	U8 sav_int_sof_enable;
	U8 c;

	Usb_ack_event(EVT_HOST_SOF);
	sav_int_sof_enable=Is_host_sof_interrupt_enabled();
	Host_enable_sof_interrupt();			// SOFĳo͊荞ݻٰݓłB
	while(Is_not_usb_event(EVT_HOST_SOF))	// 1SOFҋ@
	{
		if (Is_host_emergency_exit())
		{
			c=CONTROL_TIMEOUT;
			Host_freeze_pipe();
			Host_reset_pipe(0);
			goto host_send_control_end;
		}
	}
	if (sav_int_sof_enable==FALSE)
	{
		Host_disable_sof_interrupt();
	}

	Host_select_pipe(0);
	Host_set_token_setup();
	Host_ack_setup();
	Host_unfreeze_pipe();
	// \ݒ(SETUP)v̈\z
	Host_write_byte(usb_request.bmRequestType);
	Host_write_byte(usb_request.bRequest);
	Host_write_byte(LSB(usb_request.wValue));
	Host_write_byte(MSB(usb_request.wValue));
	Host_write_byte(LSB(usb_request.wIndex));
	Host_write_byte(MSB(usb_request.wIndex));
	Host_write_byte(LSB(usb_request.wLength));
	Host_write_byte(MSB(usb_request.wLength));

	Host_send_setup();
	while(Is_host_setup_sent() == FALSE)	// \ݒ(SETUP)҂
	{
#if (USB_OTG_FEATURE == ENABLED)
		if (Is_timeout_bdev_response_overflow())
		{
			Otg_print_new_failure_message(OTGMSG_DEVICE_NO_RESP,OTG_TEMPO_4SEC);
			c=CONTROL_TIMEOUT;
			Host_freeze_pipe();
			Host_reset_pipe(0);
			goto host_send_control_end;
		}
#endif
		if (Is_host_emergency_exit())
		{
			c=CONTROL_TIMEOUT;
			Host_freeze_pipe();
			Host_reset_pipe(0);
			goto host_send_control_end;
		}
		if(Is_host_pipe_error())			// ُ?
		{
			c = Host_error_status();
			Host_ack_all_errors();
			goto host_send_control_end;		// ُԑo
		}
	}
	// \ݒ(SETUP)w[oAIN܂OUTw[o
	// x1SOF҂̑O
	Usb_ack_event(EVT_HOST_SOF);
	sav_int_sof_enable=Is_host_sof_interrupt_enabled();
	Host_enable_sof_interrupt();
	Host_freeze_pipe();
	data_length = usb_request.wLength;
	while(Is_not_usb_event(EVT_HOST_SOF))	// 1SOFҋ@
	{
		if (Is_host_emergency_exit())
		{
			c=CONTROL_TIMEOUT;
			Host_freeze_pipe();
			Host_reset_pipe(0);
			goto host_send_control_end;
		}
	}
	if (sav_int_sof_enable==FALSE)
	{ Host_disable_sof_interrupt(); }		// SOF荞݋

	// INvǗ ---------------------------------------------
	if(usb_request.bmRequestType & 0x80)	// bmRequestType : INްiK(bmRequestType==1)
	{
		Host_standard_in_mode();
		Host_set_token_in();
		while(data_length != 0)
		{
			Host_unfreeze_pipe();
			while(!Is_host_control_in_received())
			{
				if (Is_host_emergency_exit())
				{
					c=CONTROL_TIMEOUT;
					Host_freeze_pipe();
					Host_reset_pipe(0);
					goto host_send_control_end;
				}
	#if (USB_OTG_FEATURE == ENABLED)
				if (Is_timeout_bdev_response_overflow())
				{
					Otg_print_new_failure_message(OTGMSG_DEVICE_NO_RESP,OTG_TEMPO_4SEC);
					c=CONTROL_TIMEOUT;
					Host_freeze_pipe();
					Host_reset_pipe(0);
					goto host_send_control_end;
				}
	#endif
				if(Is_host_pipe_error())
				{
					c = Host_error_status();
					Host_ack_all_errors();
					goto host_send_control_end;
				}
				if(Is_host_stall())
				{
					c=CONTROL_STALL;
					Host_ack_stall();
					goto host_send_control_end;
				}
			}
			c = Host_data_length_U8();
			if (c == Host_get_pipe_length())
			{
				data_length -= c;
				if (usb_request.uncomplete_read == TRUE)	// uncomplete_read
				{
					data_length = 0;
				}
			}
			else
			{
				data_length = 0;
			}
			while (c!=0)
			{
				*data_pointer = Host_read_byte();
				data_pointer++;
				c--;
			}
			Host_freeze_pipe();
			Host_ack_control_in();
			Host_send_control_in();
		} // INްiKI

		Host_set_token_out();
		Host_unfreeze_pipe();
		Host_ack_control_out();
		Host_send_control_out();
		while(!Is_host_control_out_sent())
		{
	#if (USB_OTG_FEATURE == ENABLED)
			if (Is_timeout_bdev_response_overflow())
			{
				Otg_print_new_failure_message(OTGMSG_DEVICE_NO_RESP,OTG_TEMPO_4SEC);
				c=CONTROL_TIMEOUT;
				Host_freeze_pipe();
				Host_reset_pipe(0);
				goto host_send_control_end;
			}
	#endif
			if (Is_host_emergency_exit())
			{
				c=CONTROL_TIMEOUT;
				Host_freeze_pipe();
				Host_reset_pipe(0);
				goto host_send_control_end;
			}
			if(Is_host_pipe_error())
			{
				c = Host_error_status();
				Host_ack_all_errors();
				goto host_send_control_end;
			}
			if(Is_host_stall())
			{
				c=CONTROL_STALL;
				Host_ack_stall();
				goto host_send_control_end;
			}
		}
		Host_ack_control_out();
		c=(CONTROL_GOOD);
		goto host_send_control_end;
	}

	// OUTvǗ ---------------------------------------------
	else									// OUTްiK(bmRequestType==0)
	{
		Host_set_token_out();
		Host_ack_control_out();
		while(data_length != 0)
		{
			Host_unfreeze_pipe();
			c = Host_get_pipe_length();
			if ( (U16)c > data_length)
			{
				c = (U8)data_length;
				data_length = 0;
			}
			else
			{
				data_length -= c;
			}
			while (c!=0)
			{
				Host_write_byte(*data_pointer);
				data_pointer++;
				c--;
			}
			Host_send_control_out();
			while (!Is_host_control_out_sent())
			{
				if (Is_host_emergency_exit())
				{
					c=CONTROL_TIMEOUT;
					Host_freeze_pipe();
					Host_reset_pipe(0);
					goto host_send_control_end;
				}
	#if (USB_OTG_FEATURE == ENABLED)
				if (Is_timeout_bdev_response_overflow())
				{
					Otg_print_new_failure_message(OTGMSG_DEVICE_NO_RESP,OTG_TEMPO_4SEC);
					c=CONTROL_TIMEOUT;
					Host_freeze_pipe();
					Host_reset_pipe(0);
					goto host_send_control_end;
				}
	#endif
				if(Is_host_pipe_error())
				{
					c = Host_error_status();
					Host_ack_all_errors();
					goto host_send_control_end;
				}
				if(Is_host_stall())
				{
					c=CONTROL_STALL;
					Host_ack_stall();
					goto host_send_control_end;
				}
			}
			Host_ack_control_out();
		} // OUTްiKI
		Host_freeze_pipe();
		Host_set_token_in();
		Host_unfreeze_pipe();
		while(!Is_host_control_in_received())
		{
			if (Is_host_emergency_exit())
			{
				c=CONTROL_TIMEOUT;
				Host_freeze_pipe();
				Host_reset_pipe(0);
				goto host_send_control_end;
			}
	#if (USB_OTG_FEATURE == ENABLED)
			if (Is_timeout_bdev_response_overflow())
			{
				Otg_print_new_failure_message(OTGMSG_DEVICE_NO_RESP,OTG_TEMPO_4SEC);
				c=CONTROL_TIMEOUT;
				Host_freeze_pipe();
				Host_reset_pipe(0);
				goto host_send_control_end;
			}
	#endif
			if(Is_host_pipe_error())
			{
				c = Host_error_status();
				Host_ack_all_errors();
				goto host_send_control_end;
			}
			if(Is_host_stall())
			{
				c=CONTROL_STALL;
				Host_ack_stall();
				goto host_send_control_end;
			}
		}
		Host_ack_control_in();
		Host_freeze_pipe();
		Host_send_control_in();
		c=(CONTROL_GOOD);
		goto host_send_control_end;
	}
host_send_control_end:
	return ((U8)c);
}

#endif //(USB_HOST_FEATURE == ENABLED)
