/**
 * @file usb_host_task.h,v
 *
 * 쌠 (c) 2004 Atmel.
 *
//! 쌠ʒmɂĂlicense.txţقǂ݂B
 *
 * @brief ̧قUSBνčƊ֐p̊֐`܂݂܂B
 *
 * @version 1.10 at90usb128-otg-dual_role-toggle-1_0_0 $Id: usb_host_task.h,v 1.10 2007/02/13 10:17:12 arobert Exp $
 *
 * @todo
 * @bug
 */

#ifndef _USB_HOST_TASK_H_
#define _USB_HOST_TASK_H_

//_____ ݸٰ ____________________________________________________________

//_____ ^ _________________________________________________________________

typedef struct
{
	bit enable;
	U16 nb_byte_to_process;
	U16 nb_byte_processed;
	U16 nb_byte_on_going;
	U8 *ptr_buf;
	void(*handle)(U8 status, U16 nb_byte);
	U8 status;
	U8 timeout;
	U16 nak_timeout;
} S_pipe_int;

//_____ ϸ ________________________________________________________________

#define PIPE_GOOD			   0
#define PIPE_DATA_TOGGLE	0x01
#define PIPE_DATA_PID		0x02
#define PIPE_PID			0x04
#define PIPE_TIMEOUT		0x08
#define PIPE_CRC16			0x10
#define PIPE_STALL			0x20
#define PIPE_NAK_TIMEOUT	0x40
#define PIPE_DELAY_TIMEOUT	0x80

//! @defgroup usb_host_task USBνčƕ
//! @{

	//! @brief uڑƐ(ڑF)ꂽTRUEԂ܂B
	//! νďʉp͐ڑꂽu։̉pvsOɂ𒲂ׂׂłB
	#define Is_host_ready()				((device_state==DEVICE_READY) ? TRUE : FALSE)

	//! ʉpuւ̗vsȂTRUEԂ܂B
	#define Is_host_not_ready()			((device_state==DEVICE_READY) ? FALSE :TRUE)

	//! νĐ킪x~(Suspend)삩
	#define Is_host_suspended()			(((device_state==DEVICE_WAIT_RESUME) ||(device_state==DEVICE_SUSPENDED)) ? TRUE : FALSE)

	//! νĐ킪x~(Suspend)łȂ
	#define Is_host_not_suspended()		(((device_state==DEVICE_WAIT_RESUME) ||(device_state==DEVICE_SUSPENDED)) ? FALSE : TRUE)

	//! νĂɐؒfꂽu邩
	#define Is_host_unattached()		((device_state==DEVICE_UNATTACHED) ? TRUE : FALSE)

	//! νĂɐڑꂽu邩
	#define Is_host_attached()			((device_state>=DEVICE_UNATTACHED) ? TRUE : FALSE)

	//! ̊֐νĐUSBx~(Suspend)ֈڍs邽߂ɌĂ΂ׂłB
	#define Host_request_suspend()		(device_state=DEVICE_SUSPENDED)

	//! ̊֐USB޽ĊJ邱ƂνĂ֗v邽߂ɌĂ΂ׂłB
	#define Host_request_resume()		(request_resume=TRUE)

	//! ĳۂɑ΂鎄I
	#define Host_ack_request_resume()	(request_resume=FALSE)

	//! ڑꂽűؾĂ()(ڑF)
	#define Host_force_enumeration()	(force_enumeration=TRUE, device_state=DEVICE_ATTACHED)

	//! ĊJ菇ɑ΂鎄I
	#define Is_host_request_resume()	((request_resume==TRUE) ? TRUE : FALSE)

	//! Vu(ڑF)ꂽTRUEԂB
	#define Is_new_device_connection_event()	(new_device_connected ? TRUE : FALSE)

	//! νĂ瑕uؒfꂽTRUEԂB
	#define Is_device_disconnection_event()		((device_state==DEVICE_DISCONNECTED_ACK || device_state==DEVICE_DISCONNECTED) ? TRUE : FALSE)

	//! ߲߂ɕtS荞݂~
	#define Host_stop_pipe_interrupt(i) (\
			Host_disable_transmit_interrupt(), \
			Host_disable_receive_interrupt(), \
			Host_disable_stall_interrupt(), \
			Host_disable_error_interrupt(), \
			Host_disable_nak_interrupt(), \
			Host_reset_pipe(i))

	//! @defgroup device_state_value νĐ
	//! uԕp`
	//! \image html host_task.gif
	//! @{
	#define DEVICE_UNATTACHED				0
	#define DEVICE_ATTACHED					1
	#define DEVICE_POWERED					2
	#define DEVICE_DEFAULT					3
	#define DEVICE_ADDRESSED				4
	#define DEVICE_CONFIGURED				5
	#define DEVICE_READY					6

	#define DEVICE_ERROR					7

	#define DEVICE_SUSPENDED				8
	#define DEVICE_WAIT_RESUME				9

	#define DEVICE_DISCONNECTED				10
	#define DEVICE_DISCONNECTED_ACK			11

	#define A_PERIPHERAL					12	// OTGłA-uɑ΂Ďgp
	#define A_INIT_HNP						13
	#define A_SUSPEND						14
	#define A_END_HNP_WAIT_VFALL			15
	#define A_TEMPO_VBUS_DISCHARGE			16
	//! @}


	#define Host_set_device_supported()		(device_status |=  0x01)
	#define Host_clear_device_supported()	(device_status &= ~0x01)
	#define Is_host_device_supported()		(device_status &   0x01)

	#define Host_set_device_ready()			(device_status |=  0x02)
	#define Host_clear_device_ready()		(device_status &= ~0x02)
	#define Is_host_device_ready()			(device_status &   0x02)

	#define Host_set_configured()			(device_status |=  0x04)
	#define Host_clear_configured()			(device_status &= ~0x04)
	#define Is_host_configured()			(device_status &   0x04)

	#define Host_clear_device_status()		(device_status  =  0x00)

//_____ 錾 _______________________________________________________________

/**
 * @brief ̊֐USBνēŁAƒgϐĊ荞
 * ݂܂B
 *
 * ̊֐USBνē`ԗpɋ܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 *
 */
void usb_host_task_init (void);

/**
 * @brief νĊǗ̓_
 *
 * _͑u(device_state)ɉđuڕWڑƗ(ڑF)Ǘ邱
 * ƂŁA֐͑u̗񋓂ƌ`Ԑݒ𓾂̂ɕKvȑs܂B
 * UuɂȂƁAdevice_stateDEVICE_READYłB
 * ̏Ԃ͑uɂǂ̉pvŝɂ旧νčƉpɂČ
 * ׂłB
 * ̊֐͌ݑIĂUSB`(u܂ν)Ɉˑusb_task֐
 * Ă΂܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 *
 */
void usb_host_task (void);

/**
  * @brief ̊֐͎w肳ꂽ߲ߔԍ*bufŎwnb_data𑗂܂B
  *
  * @note ̊֐͎Ԓ߂o邽߂νSOF荞݂ɂ܂B荞݋SOF͕܂B
  * interrupt enable sof will be restore.
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  *
  * @return	(0OK)
  */
U8 host_send_data (U8 pipe, U16 nb_data, U8 *buf);

/**
  * @brief ̊֐͎w肳ꂽ߲ߔԍ*bufŎwnb_data󂯎܂B
  *
  * nb_dataҰU16߲ƂēnA]Ă߲ɂĎwꂽް
  * ͎󂯎ŏIIް ޲ĐōXV܂B
  *
  * @note ̊֐͎Ԓ߂o邽߂νSOF荞݂ɂ܂B
  * ݋SOF܂B
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  *
  * @return	(0OK)
  */
U8 host_get_data (U8 pipe, U16 *nb_data, U8 *buf);

U8 host_get_data_interrupt (U8 pipe, U16 nb_data, U8 *buf, void (*handle)(U8 status, U16 nb_byte));

U8 host_send_data_interrupt (U8 pipe, U16 nb_data, U8 *buf, void (*handle)(U8 status, U16 nb_byte));

void reset_it_pipe_str (void);

U8 is_any_interrupt_pipe_active (void);

extern U8 ep_table[];
extern U8 device_state;
extern U8 request_resume;
extern U8 new_device_connected;
extern U8 force_enumeration;

extern U8 usb_configuration_nb;

// OTG`Aϐϸ
// ==================

//! @defgroup usb_host_task USBνOTGƕ
//! @{

#ifndef USB_OTG_FEATURE
  #define USB_OTG_FEATURE	DISABLED
#endif

// ϖƎgp̋LqɂĂ"usb_host_task.c"B
extern U16 otg_ta_srp_wait_connect;
extern U16 otg_ta_aidl_bdis_tmr;
extern U8 otg_ta_vbus_rise;
extern U16 otg_timeout_bdev_respond;
extern U16 otg_end_hnp_vbus_delay;

extern U8 otg_a_device_srp;
extern U8 otg_device_connected;

  //! MꂽSRPB-u̐ڑ(zVBUS)҂?
#define Srp_received_and_waiting_connect()		(otg_a_device_srp |= 0x01)
#define Ack_srp_received_and_connect()			(otg_a_device_srp &= ~0x01)
#define Is_srp_received_and_waiting_connect()	(((otg_a_device_srp&0x01) != 0) ? TRUE : FALSE)
  //! ݂̍ƂSRPŊJnꂽ?
#define Host_session_started_srp()				(otg_a_device_srp |= 0x02)
#define Host_end_session_started_srp()			(otg_a_device_srp &= ~0x02)
#define Is_host_session_started_srp()			(((otg_a_device_srp&0x02) != 0) ? TRUE : FALSE)

  //! ݂̎Ӌ@\OTGu?
#define Peripheral_is_not_otg_device()			(otg_device_connected = 0x00)
#define Peripheral_is_otg_device()				(otg_device_connected = 0x11)
#define Is_peripheral_otg_device()				((otg_device_connected != 0) ? TRUE : FALSE)

  //! SRPVBUSzԂ̌v킪o߂
#define T_VBUS_DELIV_AFTER_SRP					0xDAC	// USRPMƁAVBUSONł̍ŏ(~2msA5s<t<30s)
#define Init_ta_srp_counter()					(otg_ta_srp_wait_connect = 0)
#define Is_ta_srp_counter_overflow()			((otg_ta_srp_wait_connect > T_VBUS_DELIV_AFTER_SRP) ? TRUE : FALSE)
  //! A-x~(Suspend)x̌v킪o߂
#define TA_AIDL_BDIS							0x800	// VBUS~OA-SUSPENDԂł̍ŏ(~2msA>200msłȂ΂Ȃ܂B)
														// l=0̏ꍇA͖xłB
#define Init_ta_aidl_bdis_counter()				(otg_ta_aidl_bdis_tmr = TA_AIDL_BDIS)
#define Is_ta_aidl_bdis_counter_overflow()		((otg_ta_aidl_bdis_tmr == 0x0001) ? TRUE : FALSE)
  //! otg_timeout_bdev_respondv킪o߂
#define TM_OUT_MAX_BDEV_RESPONSE				0xD00	// UtB-ủA-uɑ΂őx
#define Init_timeout_bdev_response()			(otg_timeout_bdev_respond = TM_OUT_MAX_BDEV_RESPONSE)
#define Is_timeout_bdev_response_overflow()		((otg_timeout_bdev_respond == 0) ? TRUE : FALSE)
  //! otg_ta_vbus_risev킪o߂
#define TA_VBUS_RISE							0x28	// vꂽVa_vbus_valid臒lɒBVBUSɑ΂őx(<100msłȂ΂Ȃ܂B)
#define Init_ta_vbus_rise_counter()				(otg_ta_vbus_rise = TA_VBUS_RISE)
#define Is_ta_vbus_rise_counter_overflow()		((otg_ta_vbus_rise == 0) ? TRUE : FALSE)
  //! otg_ta_vbus_fallv킪o߂
#define TA_VBUS_FALL							50
#define Init_ta_vbus_fall_counter()				(otg_end_hnp_vbus_delay = TA_VBUS_FALL)
#define Is_ta_vbus_fall_counter_overflow()		((otg_end_hnp_vbus_delay == 0) ? TRUE : FALSE)

//! @}  // USBνOTG̏I

#endif /* _USB_HOST_TASK_H_ */
